Files
linux-apfs/scripts/kconfig/Makefile
T

336 lines
12 KiB
Makefile
Raw Normal View History

2005-04-16 15:20:36 -07:00
# ===========================================================================
# Kernel configuration targets
# These targets are used from top-level makefile
PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
2009-04-29 22:52:23 -04:00
localmodconfig localyesconfig
2005-04-16 15:20:36 -07:00
2008-08-25 04:51:27 -04:00
ifdef KBUILD_KCONFIG
Kconfig := $(KBUILD_KCONFIG)
else
Kconfig := Kconfig
2008-08-25 04:51:27 -04:00
endif
# We need this, in case the user has it in its environment
unexport CONFIG_
2005-04-16 15:20:36 -07:00
xconfig: $(obj)/qconf
$< $(Kconfig)
2005-04-16 15:20:36 -07:00
gconfig: $(obj)/gconf
$< $(Kconfig)
2005-04-16 15:20:36 -07:00
menuconfig: $(obj)/mconf
$< $(Kconfig)
2005-04-16 15:20:36 -07:00
config: $(obj)/conf
2010-07-31 23:35:26 +02:00
$< --oldaskconfig $(Kconfig)
2005-04-16 15:20:36 -07:00
nconfig: $(obj)/nconf
$< $(Kconfig)
2005-04-16 15:20:36 -07:00
oldconfig: $(obj)/conf
2010-07-31 23:35:26 +02:00
$< --$@ $(Kconfig)
2005-04-16 15:20:36 -07:00
silentoldconfig: $(obj)/conf
$(Q)mkdir -p include/config include/generated
2010-07-31 23:35:26 +02:00
$< --$@ $(Kconfig)
2005-04-16 15:20:36 -07:00
localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
$(Q)mkdir -p include/config include/generated
$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
2010-08-04 14:05:07 +02:00
$(Q)if [ -f .config ]; then \
2010-07-31 23:35:26 +02:00
cmp -s .tmp.config .config || \
(mv -f .config .config.old.1; \
mv -f .tmp.config .config; \
$(obj)/conf --silentoldconfig $(Kconfig); \
mv -f .config.old.1 .config.old) \
else \
mv -f .tmp.config .config; \
$(obj)/conf --silentoldconfig $(Kconfig); \
2009-05-07 11:09:55 -04:00
fi
$(Q)rm -f .tmp.config
2008-01-11 23:40:00 +01:00
# Create new linux.pot file
2007-06-10 20:38:27 +02:00
# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
2008-01-11 23:46:11 +01:00
update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
2011-12-18 18:15:16 -05:00
$(Q)echo " GEN config.pot"
$(Q)xgettext --default-domain=linux \
--add-comments --keyword=_ --keyword=N_ \
--from-code=UTF-8 \
--files-from=$(srctree)/scripts/kconfig/POTFILES.in \
--directory=$(srctree) --directory=$(objtree) \
2007-06-10 20:38:27 +02:00
--output $(obj)/config.pot
$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
$(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
$(srctree)/arch/*/um/Kconfig`; \
2008-01-11 23:40:00 +01:00
do \
2011-12-18 18:15:16 -05:00
echo " GEN $$i"; \
2008-04-25 21:15:41 +02:00
$(obj)/kxgettext $$i \
2008-01-11 23:40:00 +01:00
>> $(obj)/config.pot; \
done )
2011-12-18 18:15:16 -05:00
$(Q)echo " GEN linux.pot"
2008-01-11 23:40:00 +01:00
$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
2007-06-10 20:38:27 +02:00
--output $(obj)/linux.pot
$(Q)rm -f $(obj)/config.pot
2005-05-05 15:09:46 -07:00
2010-07-31 23:35:31 +02:00
PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
2005-04-16 15:20:36 -07:00
2010-07-31 23:35:31 +02:00
allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
2010-07-31 23:35:26 +02:00
$< --$@ $(Kconfig)
2005-04-16 15:20:36 -07:00
PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
2005-04-16 15:20:36 -07:00
listnewconfig olddefconfig: $(obj)/conf
2010-07-31 23:35:26 +02:00
$< --$@ $(Kconfig)
2005-04-16 15:20:36 -07:00
# oldnoconfig is an alias of olddefconfig, because people already are dependent
# on its behavior(sets new symbols to their default value but not 'n') with the
# counter-intuitive name.
oldnoconfig: $(obj)/conf
$< --olddefconfig $(Kconfig)
2010-07-31 23:35:34 +02:00
savedefconfig: $(obj)/conf
$< --$@=defconfig $(Kconfig)
2005-04-16 15:20:36 -07:00
defconfig: $(obj)/conf
ifeq ($(KBUILD_DEFCONFIG),)
2010-07-31 23:35:26 +02:00
$< --defconfig $(Kconfig)
2005-04-16 15:20:36 -07:00
else
@echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
2010-07-31 23:35:26 +02:00
$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
2005-04-16 15:20:36 -07:00
endif
%_defconfig: $(obj)/conf
2010-07-31 23:35:26 +02:00
$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
2005-04-16 15:20:36 -07:00
configfiles=$(wildcard $(srctree)/kernel/configs/$(1).config $(srctree)/arch/$(SRCARCH)/configs/$(1).config)
define mergeconfig
$(if $(wildcard $(objtree)/.config),, $(error You need an existing .config for this target))
$(if $(call configfiles,$(1)),, $(error No configuration exists for this target on this architecture))
$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m -O $(objtree) $(objtree)/.config $(call configfiles,$(1))
$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
endef
PHONY += kvmconfig
kvmconfig:
$(call mergeconfig,kvm_guest)
2005-04-16 15:20:36 -07:00
# Help text used by make help
help:
@echo ' config - Update current config utilising a line-oriented program'
@echo ' nconfig - Update current config utilising a ncurses menu based program'
2005-04-16 15:20:36 -07:00
@echo ' menuconfig - Update current config utilising a menu based program'
@echo ' xconfig - Update current config utilising a QT based front-end'
@echo ' gconfig - Update current config utilising a GTK based front-end'
@echo ' oldconfig - Update current config utilising a provided .config as base'
@echo ' localmodconfig - Update current config disabling modules not loaded'
2009-04-29 22:52:23 -04:00
@echo ' localyesconfig - Update current config converting local mods to core'
@echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
2010-07-31 23:35:31 +02:00
@echo ' defconfig - New config with default from ARCH supplied defconfig'
2010-07-31 23:35:34 +02:00
@echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
@echo ' allnoconfig - New config where all options are answered with no'
2010-07-31 23:35:31 +02:00
@echo ' allyesconfig - New config where all options are accepted with yes'
@echo ' allmodconfig - New config selecting modules when possible'
@echo ' alldefconfig - New config with all symbols set to default'
@echo ' randconfig - New config with random answer to all options'
@echo ' listnewconfig - List new options'
@echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
@echo ' kvmconfig - Enable additional options for guest kernel support'
2005-04-16 15:20:36 -07:00
# lxdialog stuff
check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
# Use recursively expanded variables so we do not call gcc unless
# we really need to do so. (Do not call gcc as part of make mrproper)
2010-08-22 20:03:06 -04:00
HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
-DLOCALE
2005-04-16 15:20:36 -07:00
# ===========================================================================
# Shared Makefile for the various kconfig executables:
# conf: Used for defconfig, oldconfig and related targets
# nconf: Used for the nconfig target.
# Utilizes ncurses
# mconf: Used for the menuconfig target
2005-04-16 15:20:36 -07:00
# Utilizes the lxdialog package
# qconf: Used for the xconfig target
# Based on QT which needs to be installed to compile it
# gconf: Used for the gconfig target
# Based on GTK which needs to be installed to compile it
# object files used by all kconfig flavours
lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
2005-04-16 15:20:36 -07:00
conf-objs := conf.o zconf.tab.o
mconf-objs := mconf.o zconf.tab.o $(lxdialog)
nconf-objs := nconf.o zconf.tab.o nconf.gui.o
2005-05-05 15:09:46 -07:00
kxgettext-objs := kxgettext.o zconf.tab.o
qconf-cxxobjs := qconf.o
2011-06-01 16:14:47 -04:00
qconf-objs := zconf.tab.o
gconf-objs := gconf.o zconf.tab.o
2005-04-16 15:20:36 -07:00
hostprogs-y := conf
ifeq ($(MAKECMDGOALS),nconfig)
hostprogs-y += nconf
endif
ifeq ($(MAKECMDGOALS),menuconfig)
hostprogs-y += mconf
endif
2011-04-26 17:57:38 -04:00
ifeq ($(MAKECMDGOALS),update-po-config)
hostprogs-y += kxgettext
endif
2005-04-16 15:20:36 -07:00
ifeq ($(MAKECMDGOALS),xconfig)
qconf-target := 1
endif
ifeq ($(MAKECMDGOALS),gconfig)
gconf-target := 1
endif
ifeq ($(qconf-target),1)
hostprogs-y += qconf
2005-04-16 15:20:36 -07:00
endif
ifeq ($(gconf-target),1)
hostprogs-y += gconf
2005-04-16 15:20:36 -07:00
endif
2011-06-01 16:14:47 -04:00
clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
2011-05-23 01:08:19 -04:00
clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
clean-files += mconf qconf gconf nconf
2008-01-11 23:40:00 +01:00
clean-files += config.pot linux.pot
2005-04-16 15:20:36 -07:00
# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
PHONY += $(obj)/dochecklxdialog
$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
$(obj)/dochecklxdialog:
$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
always := dochecklxdialog
# Add environment specific flags
HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
2005-10-30 15:03:20 -08:00
2005-04-16 15:20:36 -07:00
# generated files seem to need this to find local include files
2011-05-23 01:08:19 -04:00
HOSTCFLAGS_zconf.lex.o := -I$(src)
2005-04-16 15:20:36 -07:00
HOSTCFLAGS_zconf.tab.o := -I$(src)
2011-05-23 02:08:52 -04:00
LEX_PREFIX_zconf := zconf
YACC_PREFIX_zconf := zconf
2011-06-01 16:14:47 -04:00
HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
2005-04-16 15:20:36 -07:00
2011-06-01 16:14:47 -04:00
HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
2006-01-02 11:25:30 +01:00
HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
-Wno-missing-prototypes
2005-04-16 15:20:36 -07:00
HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
HOSTLOADLIBES_nconf = $(shell \
pkg-config --libs menu panel ncurses 2>/dev/null \
|| echo "-lmenu -lpanel -lncurses" )
2005-04-16 15:20:36 -07:00
$(obj)/qconf.o: $(obj)/.tmp_qtcheck
ifeq ($(qconf-target),1)
2005-11-21 21:32:38 -08:00
$(obj)/.tmp_qtcheck: $(src)/Makefile
2005-04-16 15:20:36 -07:00
-include $(obj)/.tmp_qtcheck
# QT needs some extra effort...
$(obj)/.tmp_qtcheck:
2005-11-21 21:32:38 -08:00
@set -e; echo " CHECK qt"; dir=""; pkg=""; \
2010-08-31 17:34:37 +02:00
if ! pkg-config --exists QtCore 2> /dev/null; then \
echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
pkg-config --exists qt 2> /dev/null && pkg=qt; \
pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
if [ -n "$$pkg" ]; then \
cflags="\$$(shell pkg-config $$pkg --cflags)"; \
libs="\$$(shell pkg-config $$pkg --libs)"; \
moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
dir="$$(pkg-config $$pkg --variable=prefix)"; \
else \
for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
done; \
if [ -z "$$dir" ]; then \
echo >&2 "*"; \
echo >&2 "* Unable to find any QT installation. Please make sure that"; \
echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
echo >&2 "* either qmake can be found or install pkg-config or set"; \
echo >&2 "* the QTDIR environment variable to the correct location."; \
echo >&2 "*"; \
2010-08-31 17:34:37 +02:00
false; \
fi; \
libpath=$$dir/lib; lib=qt; osdir=""; \
$(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
test -f $$libpath/libqt-mt.so && lib=qt-mt; \
cflags="-I$$dir/include"; \
libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
moc="$$dir/bin/moc"; \
fi; \
if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
echo "*"; \
echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
echo "*"; \
moc="/usr/bin/moc"; \
fi; \
else \
2010-09-13 13:41:31 +02:00
cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
2012-07-04 15:23:29 -05:00
moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
[ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
2005-11-21 21:32:38 -08:00
fi; \
echo "KC_QT_CFLAGS=$$cflags" > $@; \
echo "KC_QT_LIBS=$$libs" >> $@; \
echo "KC_QT_MOC=$$moc" >> $@
2005-04-16 15:20:36 -07:00
endif
$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
ifeq ($(gconf-target),1)
-include $(obj)/.tmp_gtkcheck
# GTK needs some extra effort, too...
$(obj)/.tmp_gtkcheck:
2006-01-02 11:25:30 +01:00
@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
2005-04-16 15:20:36 -07:00
touch $@; \
else \
echo >&2 "*"; \
echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
echo >&2 "*"; \
2005-04-16 15:20:36 -07:00
false; \
fi \
else \
echo >&2 "*"; \
echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
echo >&2 "*"; \
2005-04-16 15:20:36 -07:00
false; \
fi
endif
2011-05-23 01:08:19 -04:00
$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
2005-04-16 15:20:36 -07:00
2011-06-01 16:14:47 -04:00
$(obj)/qconf.o: $(obj)/qconf.moc
2005-04-16 15:20:36 -07:00
2012-07-04 18:31:11 -05:00
quiet_cmd_moc = MOC $@
cmd_moc = $(KC_QT_MOC) -i $< -o $@
$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
$(call cmd,moc)
2005-04-16 15:20:36 -07:00
2008-01-11 23:46:11 +01:00
# Extract gconf menu items for I18N support
$(obj)/gconf.glade.h: $(obj)/gconf.glade
2011-04-26 18:16:53 -04:00
$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
$(obj)/gconf.glade